require 'uu/os/lang/uniform_hash'

module UU
  module OS
    module HTTP

      # Object representing HTTP query with Hash-like API.
      class HTTPQuery < UU::OS::Lang::UniformHash

        # Creates new instance of HTTPQuery.
        # @private
        def initialize(obj = nil) # :nodoc:
          if obj.kind_of?Hash
            self.replace(obj)
          else
            super(obj)
          end
        end

        # Translates all given keys to symbol.
        # @private
        def transform_key(key) # :nodoc:
          return nil if key.nil?
          if key.kind_of?Symbol
            return key
          else
            return key.to_s.to_sym
          end
        end

      end

    end
  end
end
